
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author cteam038
 */
public class Fs {

    private static Map<String, String> charsToMorse = new HashMap<String, String>();
    private static Map<String, String> morseToChars = new HashMap<String, String>();
    
    static {
        charsToMorse.put("A",".-");
        charsToMorse.put("B","-...");
        charsToMorse.put("C","-.-.");
        charsToMorse.put("D","-..");
        charsToMorse.put("E",".");
        charsToMorse.put("F","..-.");
        charsToMorse.put("G","--.");
        charsToMorse.put("H","....");
        charsToMorse.put("I","..");
        charsToMorse.put("J",".---");
        charsToMorse.put("K","-.-");
        charsToMorse.put("L",".-..");
        charsToMorse.put("M","--");
        charsToMorse.put("N","-.");
        charsToMorse.put("O","---");
        charsToMorse.put("P",".--.");
        charsToMorse.put("Q","--.-");
        charsToMorse.put("R",".-.");
        charsToMorse.put("S","...");
        charsToMorse.put("T","-");
        charsToMorse.put("U","..-");
        charsToMorse.put("V","...-");
        charsToMorse.put("W",".--");
        charsToMorse.put("X","-..-");
        charsToMorse.put("Y","-.--");
        charsToMorse.put("Z","--..");
        charsToMorse.put("_","..--");
        charsToMorse.put(".","---.");
        charsToMorse.put(",",".-.-");
        charsToMorse.put("?","----");
        for (String ch : charsToMorse.keySet()) {
            morseToChars.put(charsToMorse.get(ch), ch);
        }
    }
    
    public static void main(String [] args) {
        Scanner scanner = new Scanner(System.in);
        while (scanner.hasNextLine()) {
            String line = scanner.nextLine();
            
            StringBuilder strBuilder = new StringBuilder();
            List<Integer> list = new LinkedList<Integer>();
            for (int i=0;i<line.length();i++) {
                String ch = line.substring(i, i+1);
                String morse = charsToMorse.get(ch);
                strBuilder.append(morse);
                list.add(0,morse.length());
            }
            
            
            StringBuilder sb = new StringBuilder();
            String encoded = strBuilder.toString();
            int i=0;
            for (Integer len : list) {
                sb.append(morseToChars.get(encoded.substring(i, i + len)));
                i += len;
            }
            System.out.println(sb);
        }
    }

    
}
